#ifndef INTEGRATOR_H_
#define INTEGRATOR_H_

class Integrator
{
public:
    explicit Integrator(float initial = 0);

    float value() const;
    float speed() const;
    float accumulate(float accel, float dt);

private:
    float prev_;
    float speed_;
    float value_;
};

class INS
{
public:
    INS();

    float posX() const;
    float posY() const;
    float posZ() const;
    float rotX() const;
    float rotY() const;
    float rotZ() const;

    float posDX() const;
    float posDY() const;
    float posDZ() const;
    float rotDX() const;
    float rotDY() const;
    float rotDZ() const;

    float grvX() const;
    float grvY() const;
    float grvZ() const;

    void setGravity(float ax, float ay, float az);

    void accumulate(float px, float py, float pz,
        float rx, float ry, float rz, float dt);

private:
    float gx_, gy_, gz_;
    Integrator posX_, posY_, posZ_;
    Integrator rotX_, rotY_, rotZ_;
};

#endif // INTEGRATOR_H_
